{   $Id: stack.pas,v 1.15 2002/12/21 05:37:52 dodi Exp $

    OpenXP generic stack unit

    Copyright (C) 1991-2001 Peter Mandrella
    Copyright (C) 2000-2002 OpenXP team (www.openxp.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

{$I xpdefine.inc }

unit stack;

interface

uses
  xpglobal;

procedure spush(var x; size:xpWord);
procedure spop(var x);

implementation

type  stp = ^ste;
      ste = record
              inhalt : pointer;
              groesse: xpWord;
              adr    : pointer;    { fuer Integritaets-Test }
              next   : stp;
              last   : stp;
            end;

var   tail : stp = nil;


{$IFDEF Debug }
procedure error(txt:string);
begin
  writeln('<Stack> ',txt);
  halt(1);
end;
{$ENDIF }


procedure spush(var x; size:xpWord);
var p : stp;
begin
  new(p);
  if tail=nil then begin
    tail:=p;
    p^.next:=nil; p^.last:=nil;
    end
  else begin
    p^.last:=tail;
    p^.next:=nil;
    tail:=p;
    end;
  getmem(p^.inhalt,size);
  Move(x,p^.inhalt^,size);
  p^.groesse:=size;
  p^.adr:=@x
end;


procedure spop(var x);
var p : stp;
begin
{$IFDEF Debug }
  if tail=nil then
    error('Underflow');
  if @x<>tail^.adr then
    error('var mismatch');
{$ENDIF }
  Move(tail^.inhalt^,x,tail^.groesse);
  freemem(tail^.inhalt,tail^.groesse);
  p:=tail;
  tail:=tail^.last;
  dispose(p);
end;


{
  $Log: stack.pas,v $
  Revision 1.15  2002/12/21 05:37:52  dodi
  - removed questionable references to Word type

  Revision 1.14  2002/12/12 11:58:41  dodi
  - set $WRITEABLECONT OFF

  Revision 1.13  2002/12/06 14:27:27  dodi
  - updated uses, comments and todos

  Revision 1.12  2002/07/25 20:43:53  ma
  - updated copyright notices

  Revision 1.11  2001/09/10 15:58:01  ml
  - Kylix-compatibility (xpdefines written small)
  - removed div. hints and warnings

  Revision 1.10  2001/09/08 16:29:30  mk
  - use FirstChar/LastChar/DeleteFirstChar/DeleteLastChar when possible
  - some AnsiString fixes

  Revision 1.9  2001/03/13 19:24:56  ma
  - added GPL headers, PLEASE CHECK!
  - removed unnecessary comments

  Revision 1.8  2000/08/19 09:41:36  mk
  - Code aufgeraeumt

  Revision 1.7  2000/07/02 14:24:49  mk
  - FastMove entfernt, da in FPC/VP RTL besser implementiert

  Revision 1.6  2000/06/29 13:00:49  mk
  - 16 Bit Teile entfernt
  - OS/2 Version luft wieder
  - Jochens 'B' Fixes bernommen
  - Umfangreiche Umbauten fr Config/Anzeigen/Zeilen
  - Modeminitialisierung wieder an alten Platz gelegt
  - verschiedene weitere fixes

  Revision 1.5  2000/04/30 16:07:09  mk
  - xpglobal in den Interface-Teil vorgezogen

  Revision 1.4  2000/04/30 15:55:46  mk
  - Debugcode nur noch bei $DEF Debug

  Revision 1.3  2000/02/19 11:40:07  mk
  Code aufgeraeumt und z.T. portiert

}
end.

